/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahl;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahl.boundary.AbstractWahlParameterSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlParameterChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlParameterConversationStore;
import de.ivu.elect.business.wahl.boundary.WahlParameterExtendedDAO;
import de.ivu.elect.business.wahl.boundary.WahlParameterSearch;
import de.ivu.elect.business.wahl.boundary.WahlParameterSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahl.entity.WahlParameter;
import de.ivu.elect.business.wahl.entity.WahlParameterMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlParameterSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlParameterSearchView.VIEW_ID, useCase = UseCasePermission.WAHL_PARAMETER_SEARCH)
public abstract class AbstractWahlParameterSearchView extends AbstractElectSearchView<WahlParameter> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlParameterSearchView";
  
  public static final String VIEW_ID = "/wahl/wahl-parameter-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlParameterSearchView requestHandler;

  @Inject
  private transient WahlParameterExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlParameterConversationStore.class)
  protected transient WahlParameterConversationStore conversationStore;

  @Inject
  protected transient WahlParameterSearch search;

  @Inject
  @ConversationGroup(AbstractWahlParameterSearchParameters.class)
  protected transient WahlParameterSearchParameters searchParameters;

  @Inject
  protected transient WahlParameterMeta entityMeta;

  public AbstractWahlParameterSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WahlParameter getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WahlParameter entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlParameterSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WahlParameter> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WahlParameter> create();
  }

  @Override
  public List<WahlParameter> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WahlParameter> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlParameterChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlParameterChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlParameterSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlParameterSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlParameterSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
